Subject: Re: [netmod] update on "rdns" URN for enterprise YANG models

From: "Ing-Wher (Helen) Chen" <[email-masked]>
Date: Thu, 9 Jun 2016 21:06:31 +0000

> -----Original Message-----
> From: Alex Campbell [mailto:[email-masked]]
> Sent: Thursday, May 26, 2016 8:54 PM
> To: Ing-Wher (Helen) Chen <[email-masked]>
> Cc: [email-masked]
> Subject: Re: [netmod] update on "rdns" URN for enterprise YANG models
> 
> 
> > From: netmod <[email-masked]> on behalf of Ing-Wher (Helen)
> > Chen <[email-masked]>
> > Sent: Thursday, 21 April 2016 2:40 a.m.
> > To: Juergen Schoenwaelder
> > Cc: [email-masked]
> > Subject: Re: [netmod] update on "rdns" URN for enterprise YANG models
> >
> > > -----Original Message-----
> > > From: Juergen Schoenwaelder [mailto:j.schoenwaelder@jacobs-
> > > university.de]
> > > Sent: Tuesday, April 19, 2016 2:23 PM
> > > To: Ing-Wher (Helen) Chen <[email-masked]>
> > > Cc: [email-masked]
> > > Subject: Re: [netmod] update on "rdns" URN for enterprise YANG
> > > models
> > >
> > > On Tue, Apr 19, 2016 at 04:23:51PM +0000, Ing-Wher (Helen) Chen
> wrote:
> > > > I'm not an expert on XML namespaces and I'm a little confused by
> > > > some of the questions, so I apologize if my response below does
> > > > not quite answer the questions.  I'd like to point out that the
> > > > request for "rdns" URN is not to prevent the use of URLs. The request
> for "rdns"
> > > > URN is to allow an enterprise to easily create a URN namespace, if
> > > > the enterprise happens to prefer to use URN as a YANG module
> > > > namespace.  I also think that the problems that arise when a YANG
> > > > module uses a URN based on an enterprise's domain name are the
> > > > same problems that arise when a YANG module uses a URL based on an
> enterprise's domain name.
> > > > (Of course, this is not an excuse to fix the problems that should
> > > > be
> > > > fixed.)
> > >
> > > You write "happen to prefer to use URN" - why?
> 
> > draft-chen-rdns-urn Section 4
> > <https://tools.ietf.org/html/draft-chen-rdns-urn-06#section-4>
> > discusses why an enterprise might prefer to use URN over URL.  URL
> > provides resource access mechanism, which might mislead a customer to
> > request that the YANG module be accessible at a specific location.
> > It's true that the device does not care that the YANG module is not at
> > a particular URL, but I can still imagine getting a bug requesting that the
> YANG module be accessible at the URL.
> 
> URLs are frequently used as namespaces in XML, without referring to a
> particular resource (and most of them are HTTP URLs that return generic
> error-404 pages).
> Does this proposal suggest that YANG namespaces should be treated
> differently from XML namespaces?

No.

(Just because a URL is used as an XML Namespace doesn't mean that
the URL should be treated differently from how it's defined in
<https://tools.ietf.org/html/rfc3986> .  This seems like a reasonable
preference to me.)

Thanks,
Helen

---

From: [email-masked] (Dale R. Worley)
Date: Sun, 12 Jun 2016 21:27:44 -0400

When I see a requirement for globally unique names, I always think
fondly of the "oid" series of URNs, which are based on the ITU object
identifiers.  See RFC 3001.  You write to IANA to get an assignment of a
"private enterprise number", which you can use to coin object
identifiers which are guaranteed to be unique.  For instance, I've been
assigned OID 1.3.6.1.4.1.14490.

So I can use urn:oid:1.3.6.1.4.1.14490.1,
urn:oid:1.3.6.1.4.1.14490.2, urn:oid:1.3.6.1.4.1.14490.3, etc., and be
assured that they're globally unique.

(If you want a subtree to experiment with, I can allocate on to you!)

Sadly, nobody else seems to be taken with the extreme elegance of the
OID system.

Dale